program Otashi;

{ UJA V. 1.00, 17.06.94: 1. spielbare Version mit Handicap und High Score  }

uses crt,dos,graph,drivers,intuit,timer;

const dx=24; dy=24; ox=8; oy=24; xmax=18; ymax=10;
      hscfile='Otashi.hsc';
      imafile='Otashi.ima';
      pal:array[0..15,0..2] of word=
      (( 0,  0,  0 ),( 32,  0,  0 ),(  0, 32,  0 ),( 32, 32,  0 ),
      (  0,  0, 32 ),( 32,  0, 32 ),(  0, 32, 32 ),( 48, 48, 48 ),
      ( 32, 32, 32 ),( 63,  0,  0 ),(  0, 63,  0 ),( 63, 63,  0 ),
      (  0,  0, 63 ),( 63,  0, 63 ),(  0, 63, 63 ),( 63, 63, 63 ));

type hscliste=array[0..11] of record namen:string; score:longint end;
     feld    =array[1..xmax,1..ymax] of integer;

var igad                       :array[1..5] of gadget;
    itext1,itext2,itext3       :array[1..5] of intuitext;
    ibord1,ibord2              :array[1..5] of border;
    ima                        :array[0..37] of image;
    xy1,xy2,xy3                :koords;
    mh                         :TEvent;
    bufptr,size,pkt            :longint;
    spalte,zeile,mx,my,nchip   :integer;
    ok,fertig,ende             :boolean;
    f                          :feld;
    liste                      :array[0..159] of integer;
    ch                         :char;
    hsc                        :hscliste;

procedure holeimages;
var i,j,k:integer; anz:word;
     disk:file;
begin
   for i:=0 to 15 do begin
      setrgbpalette(i,pal[i,0],pal[i,1],pal[i,2]);
      setpalette(i,i);
   end;
   Assign(disk,imafile);
   reset(disk,1);

   BlockRead(disk,ima[0],sizeof(image),anz);
   with ima[0] do begin
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      BlockRead(disk,p_data^,anz,anz);
      putimage(0,0,ima[0].p_data^,normalput);
      FreeMem(p_data,anz);
   end;
   close(disk);
   k:=0;
   for i:=0 to 5 do for j:=0 to 5 do begin
      inc(k);
      with ima[k] do begin
         x:=0;
         y:=0;
         width:=dx;
         height:=dy;
         p_nextimage:=nil;
         anz:=imagesize(1,1,width,height);
         getmem(p_data,anz);
         getimage(i*dx,j*dy,pred(i*dx+dx),pred(j*dy+dy),p_data^);
      end;
   end;
   rectfill(0,0,pred(dx),pred(dy),4);
   rectfill(1,1,pred(dx),pred(dy),8);
   inc(k);
      with ima[k] do begin
         x:=0;
         y:=0;
         width:=dx;
         height:=dy;
         p_nextimage:=nil;
         anz:=imagesize(1,1,width,height);
         getmem(p_data,anz);
         getimage(0,0,pred(dx),pred(dy),p_data^);
      end;
end;



procedure initstructures;
var i,x1,y1:integer;
begin
   x1:=72; y1:=20;
   xy1[0]:=0;      xy1[1]:=0;       xy1[2]:=x1;      xy1[3]:=xy1[1];
   xy1[4]:=xy1[2]; xy1[5]:=y1;      xy1[6]:=xy1[0];  xy1[7]:=xy1[5];
   xy1[8]:=xy1[0]; xy1[9]:=xy1[1];
   x1:=dx*xmax+114; y1:=122;
   xy2[0]:=0;       xy2[1]:=0;       xy2[2]:=x1;      xy2[3]:=xy2[1];
   xy2[4]:=xy2[2];  xy2[5]:=y1;      xy2[6]:=xy2[0];  xy2[7]:=xy2[5];
   xy2[8]:=xy2[0];  xy2[9]:=xy2[1];
   x1:=dx*xmax+2; y1:=dy*ymax+2;
   xy3[0]:=0;      xy3[1]:=0;       xy3[2]:=x1;      xy3[3]:=xy3[1];
   xy3[4]:=xy3[2]; xy3[5]:=y1;      xy3[6]:=xy3[0];  xy3[7]:=xy3[5];
   xy3[8]:=xy3[0]; xy3[9]:=xy3[1];
   for i:=1 to 5 do begin
      with ibord1[i] do begin
         x:=-1;
         y:=-1;
         fpen:=12;
         bpen:=4;
         drmode:=jam1;
         ecken:=5;
         p_ecken:=addr(xy1);
         p_nextborder:=addr(ibord2[i]);
      end;
      ibord2[i]:=ibord1[i];
      with ibord2[i] do begin
         x:=ibord1[i].x-1;
         y:=ibord1[i].y-1;
         fpen:=0;
         p_nextborder:=nil;
      end;
   end;
   ibord1[4].p_ecken:=addr(xy2);
   ibord1[5].p_ecken:=addr(xy3);
   ibord2[4].p_ecken:=addr(xy2);
   ibord2[5].p_ecken:=addr(xy3);

   for i:=1 to 4 do with itext3[i] do begin
      x:=8;
      y:=8;
      fpen:=15;
      bpen:=9;
      drmode:=jam1;
      p_nexttext:=nil;
   end;
   itext3[1].itext:='N e u';
   itext3[2].itext:='A l t';
   itext3[3].itext:='Q u i t';
   itext3[4].itext:='T o p   T e n :';
   itext2:=itext3;
   itext1:=itext3;
   for i:=1 to 4 do begin
      with itext1[i] do begin
         x:=itext3[i].x-1;
         fpen:=2;
         p_nexttext:=addr(itext2[i]);
      end;
      with itext2[i] do begin
         x:=itext3[i].x+1;
         fpen:=0;
         p_nexttext:=addr(itext3[i]);
      end;
   end;

   for i:=1 to 3 do with igad[i] do begin
      id    :=i;
      x     :=ox+succ(xmax)*dx+40;
      y     :=oy+(ymax-3+i)*dy;
      width :=72;
      height:=20;
      bpen  :=4;
      hibpen:=14;
      p_loborder:=addr(ibord1[i]);
      p_hiborder:=nil;
      p_loimage :=nil;
      p_hiimage :=nil;
      p_lointuitext:=addr(itext1[i]);
      p_hiintuitext:=nil;
      onoff        :=false;
      active       :=true;
      p_nextgadget :=addr(igad[succ(i)]);
   end;
   i:=4;
   with igad[i] do begin
      id    :=i;
      x     :=ox+dx;
      y     :=oy+succ(ymax)*dy+16;
      width :=xmax*dx+112;
      height:=120;
      bpen  :=4;
      hibpen:=14;
      p_loborder:=addr(ibord1[i]);
      p_hiborder:=nil;
      p_loimage :=nil;
      p_hiimage :=nil;
      p_lointuitext:=addr(itext1[i]);
      p_hiintuitext:=nil;
      onoff        :=false;
      active       :=true;
      p_nextgadget :=addr(igad[succ(i)]);
   end;
   i:=5;
   with igad[i] do begin
      id    :=i;
      x     :=ox+dx;
      y     :=oy+dy;
      width :=xmax*dx;
      height:=ymax*dy;
      bpen  :=4;
      hibpen:=14;
      p_loborder:=addr(ibord1[i]);
      p_hiborder:=nil;
      p_loimage :=nil;
      p_hiimage :=nil;
      p_lointuitext:=nil;
      p_hiintuitext:=nil;
      onoff        :=false;
      active       :=true;
      p_nextgadget :=nil;
   end;

end;


{ ----- Spielfeld zeichnen ------------------------------------------ }

procedure zeichnescreen;
var i,j,x,y:integer;
    temp :string;
begin
   RectFill(0,0,639,479,0);
   RectFill(0,17,639,479,8);
   RectFill(0,0,639,15,4);
   for i:=1 to 5 do drawgadget(addr(igad[i]));

   temp:='U J A s   O t a s h i                TP6 V.1.00    (c) UJA 06/94';
   x:=80; y:=4;
   Setcolor(0);  outtextxy(x+2,y,temp);
   Setcolor(2);  outtextxy(x-1,y,temp);
   Setcolor(15); outtextxy(x,y,temp);

   temp:='Chips: xxx';
   x:=(xmax+2)*dx+ox; y:=oy+dy+6;
   Setcolor(0);  outtextxy(x+1,y,temp);
   Setcolor(2);  outtextxy(x-1,y,temp);
   Setcolor(14); outtextxy(x,y,temp);

   temp:='Nchster Chip:';
   y:=y+dy;
   Setcolor(0);  outtextxy(x+1,y,temp);
   Setcolor(2);  outtextxy(x-1,y,temp);
   Setcolor(14); outtextxy(x,y,temp);

   temp:='Punkte: xxxxx';
   y:=oy+6*dy+6;
   Setcolor(0);  outtextxy(x+1,y,temp);
   Setcolor(2);  outtextxy(x-1,y,temp);
   Setcolor(14); outtextxy(x,y,temp);

end;


procedure updatpunkte(punkte:longint);
var temp:string;
    x,y:integer;
begin
   Str(punkte:5,temp);
   y:=oy+6*dy+6;
   x:=(xmax+2)*dx+ox+64;
   RectFill(x-1,y,x+48,y+10,8);
   Setcolor(0);  outtextxy(x+1,y,temp);
   Setcolor(2);  outtextxy(x-1,y,temp);
   Setcolor(14); outtextxy(x,y,temp);
end;

procedure updatchip(c:integer);
var temp:string;
    x,y:integer;
begin
   Str(c:3,temp);
   y:=oy+dy+6;
   x:=(xmax+2)*dx+ox+56;
   RectFill(x-1,y,x+32,y+10,8);
   Setcolor(0);  outtextxy(x+1,y,temp);
   Setcolor(2);  outtextxy(x-1,y,temp);
   Setcolor(14); outtextxy(x,y,temp);
end;

procedure showchip(nr:integer);
var x,y:integer;
begin
   y:=oy+3*dy;
   x:=(xmax+4)*dx+ox;
   DrawImage(x,y,addr(ima[nr]));
end;

{ ----- Spielregeln ----------------------------------------------- }

procedure initliste;
var i,j,k,e:integer;
begin
   for i:=1 to 144 do liste[i]:=succ(i mod 36);
   for i:=145 to 159 do liste[i]:=37;
   randomize;
   for j:=1 to 10 do for i:=1 to 144 do begin
      k:=succ(random(144) mod 144);
      e:=liste[i];
      liste[i]:=liste[k];
      liste[k]:=e
   end;
end;


procedure initgame;
var i,j:integer;
begin
   hidemouse;
   for i:=1 to xmax do for j:=1 to ymax do begin
      f[i,j]:=0;
      DrawImage(i*dx+ox,j*dy+oy,addr(ima[37]));
   end;
   nchip:=138;
   pkt:=30;
   updatpunkte(pkt);
   updatchip(nchip);
   f[1,1]:=liste[1];
   drawimage(ox+dx,oy+dy,addr(ima[liste[1]]));
   f[1,ymax]:=liste[2];
   drawimage(ox+dx,oy+ymax*dy,addr(ima[liste[2]]));
   f[xmax,ymax]:=liste[3];
   drawimage(ox+xmax*dx,oy+ymax*dy,addr(ima[liste[3]]));
   f[xmax,1]:=liste[4];
   drawimage(ox+xmax*dx,oy+dy,addr(ima[liste[4]]));
   i:=xmax div 2;
   j:=ymax div 2;
   f[i+1,j]:=liste[5];
   drawimage(ox+(i+1)*dx,oy+j*dy,addr(ima[liste[5]]));
   f[i,j+1]:=liste[6];
   drawimage(ox+i*dx,oy+(j+1)*dy,addr(ima[liste[6]]));


   liste[0]:=7;
   showchip(liste[liste[0]]);
   fertig:=false;
   showmouse;
end;



procedure checkit(mx,my:integer; var ok,fertig:boolean);
var i,x,y,e,a1,a2,a3,a4,art1,art2,nachbar,bonus:integer;

begin
x:=(mx-ox) div dx;
y:=(my-oy) div dy;
ok:=f[x,y]=0;
if ok then begin
   nachbar:=0;
   art1:=0;
   art2:=0;
   e:=pred(liste[liste[0]]);
   a1:=succ(e mod 6);
   a2:=succ(e div 6);
   if x>1 then if f[x-1,y]>0 then begin
      inc(nachbar);
      a3:=succ(pred(f[x-1,y]) mod 6);
      a4:=succ(pred(f[x-1,y]) div 6);
      if a1=a3 then inc(art1);
      if a2=a4 then inc(art2);
      ok:=(a1=a3) or (a2=a4);
      ok:=ok and (not ((a1=a3) and (a2=a4)));
   end;
end;
if ok then if x<xmax then if f[x+1,y]>0 then begin
   inc(nachbar);
   a3:=succ(pred(f[x+1,y]) mod 6);
   a4:=succ(pred(f[x+1,y]) div 6);
   if a1=a3 then inc(art1);
   if a2=a4 then inc(art2);
   ok:=(a1=a3) or (a2=a4);
   ok:=ok and (not ((a1=a3) and (a2=a4)));
end;
if ok then if y<ymax then if f[x,y+1]>0 then begin
   inc(nachbar);
   a3:=succ(pred(f[x,y+1]) mod 6);
   a4:=succ(pred(f[x,y+1]) div 6);
   if a1=a3 then inc(art1);
   if a2=a4 then inc(art2);
   ok:=(a1=a3) or (a2=a4);
   ok:=ok and (not ((a1=a3) and (a2=a4)));
end;
if ok then if y>1 then if f[x,y-1]>0 then begin
   inc(nachbar);
   a3:=succ(pred(f[x,y-1]) mod 6);
   a4:=succ(pred(f[x,y-1]) div 6);
   if a1=a3 then inc(art1);
   if a2=a4 then inc(art2);
   ok:=(a1=a3) or (a2=a4);
   ok:=ok and (not ((a1=a3) and (a2=a4)));
end;
if ok then if nachbar>1 then ok:=ok and (art1>0) and (art2>0);
if ok then if nachbar=4 then ok:=ok and (art1=2) and (art2=2);


if ok then begin
   hidemouse;
   inc(e);
   DrawImage(x*dx+ox,y*dy+oy,addr(ima[e]));
   f[x,y]:=e;
   bonus:=5;
   if nachbar>0 then for i:=1 to nachbar do bonus:=bonus+bonus;
   pkt:=pkt+bonus;
   dec(nchip);
   updatchip(nchip);
   inc(liste[0]);
   updatpunkte(pkt);
   fertig:=liste[0]>144;
   showchip(liste[liste[0]]);
   showmouse;
end;
end;


{ ----- Mauskladderadatsch, vom Amiga so lala zum PC --------------- }

procedure holeevent(var key,g,mx,my,keycode1,keycode2:integer);
{ kombinierte Maus-Tastaturabfrage mit Keys }
var k,kx,ky:integer;
    temp:string;
begin
   showmouse;
   keycode1:=-1;
   keycode2:=-1;
   key:=0;
   g:=0;
   repeat
      delay1(50);
      maustastelos(key,mx,my);
      if key>0 then g:=checkgadget(addr(igad[1]),mx,my);
   until (g>0) or keypressed;

   if keypressed then begin
      keycode1:=ord(readkey);
      if keycode1=0 then keycode2:=ord(readkey);
   end;
   hidemouse;
end;






procedure mausauswerten;
var key,key1,key2,mx,my,i,j,g:integer;
    ok         :boolean;

begin
   holeevent(key,g,mx,my,key1,key2);
   if key=0 then case key1 of
   27,81,113: g:=3;
      65, 97: g:=2;
      78,110: g:=1;
   end;
   case g of
   1: begin initliste; initgame; end;
   2: initgame;
   3: ende:=true;
   5: checkit(mx,my,ok,fertig);
   end;
end;


{ ------ Fanfare- und HiScore-Krams --------------------------------- }


procedure inithiscore;
var i,j,k:integer; temp:string; disk:text;
begin
for i:=0 to 11 do with hsc[i] do score:=2000-i*100;
hsc[0].score:=9999999;
hsc[1].namen:='The Big Cheese';
hsc[2].namen:='Little Underdog';
hsc[3].namen:='Sluggy LongLong';
hsc[4].namen:='Captain Chaos';
hsc[5].namen:='Murphy ^7';
hsc[6].namen:='Henry VIII';
hsc[7].namen:='SnailEater II';
hsc[8].namen:='Killer Tomato 1';
hsc[9].namen:='Killer Tomato 2';
hsc[10].namen:='Ketchup';
{$i-}
   assign(disk,hscfile);
   reset(disk);
   if ioresult=0 then begin
      for i:=1 to 10 do with hsc[i] do begin
         readln(disk,score); readln(disk,namen);
      end;
      close(disk);
   end;
{$i+}
end;


procedure savehiscore;
var i:integer;
    disk:text;
begin
assign(disk,hscfile);
rewrite(disk);
for i:=1 to 10 do with hsc[i] do begin
   writeln(disk,score:10); writeln(disk,namen);
end;
close(disk);
end;



procedure displayhiscore;
var i,j,k,x,y:integer; temp1,temp2,temp3:string;
begin
x     :=ox+dx;
y     :=oy+succ(ymax)*dy+40;
Rectfill(x,y,x+xmax*dx+111,y+79,8);
for i:=1 to 5 do with hsc[i] do begin
   str(i:2,temp1);
   temp1:=temp1+'. '+namen;
   str(score:8,temp2);
   Setcolor(0);
   outtextxy(x+17,y+i*12,temp1);
   outtextxy(x+dx*7+1,y+i*12,temp2);
   setcolor(2);
   outtextxy(x+15,y+i*12,temp1);
   outtextxy(x+dx*7-1,y+i*12,temp2);
   Setcolor(14);
   outtextxy(x+16,y+i*12,temp1);
   outtextxy(x+dx*7,y+i*12,temp2);
end;
for i:=1 to 5 do with hsc[i+5] do begin
   str((i+5):2,temp1);
   temp1:=temp1+'. '+namen;
   str(score:8,temp2);
   Setcolor(0);
   outtextxy(x+297,y+i*12,temp1);
   outtextxy(x+dx*7+281,y+i*12,temp2);
   setcolor(2);
   outtextxy(x+295,y+i*12,temp1);
   outtextxy(x+dx*7+279,y+i*12,temp2);
   Setcolor(14);
   outtextxy(x+296,y+i*12,temp1);
   outtextxy(x+dx*7+280,y+i*12,temp2);
end;
end;


procedure updathiscore(p:longint);
var i,j,k,x,y:integer;
    cc       :char;
    t1,t2,t3 :string;
begin
   k:=10;
   while hsc[k].score<p do dec(k); inc(k);
if k<11 then begin
   for i:=10 downto k do hsc[i+1]:=hsc[i];
   with hsc[k] do begin
      score:=p;
      namen:='';
   end;
   displayhiscore;
   if k<6 then begin
      x:=ox+dx+48;
      y:=oy+succ(ymax)*dy+40+k*12;
   end else begin
      x:=ox+dx+48+280;
      y:=oy+succ(ymax)*dy+40+(k-5)*12;
   end;

   setcolor(15);
   i:=0;
   t1:='';
   cc:=#0;
   outtextxy(x,y,'_');
   repeat
      delay(50);
      if keypressed then begin
         cc:=readkey;
         if (cc>#31) and (cc<=#255) then begin
            t1:=t1+cc;
            rectfill(x+i*8,y-2,x+i*8+7,y+8,12);
            setcolor(15);
            outtextxy(x+i*8,y,cc+'_');
            inc(i);
         end else if (cc=#8) then if i>0 then begin { backspace }
            rectfill(x+(i-1)*8,y-2,x+i*8+7,y+8,12);
            setcolor(15);
            dec(i);
            outtextxy(x+i*8,y,'_');
            t2:='';
            if i>0 then begin
               for j:=1 to pred(length(t1)) do t2:=t2+t1[j];
               outtextxy(x,y,t2);
            end;
            t1:=t2;
         end;
      end;
   until (cc>#0) and (cc<>#8) and ((cc<=#31) or (i>16));
   hsc[k].namen:=t1;
   displayhiscore;
   savehiscore;
   end else displayhiscore;
end;


procedure fanfare;
var i,j,k,e:integer;
begin
for i:=1 to 1000 do begin
  j:=random(pred(xmax)*dx)+dx+ox;
  k:=random(pred(ymax)*dy)+dy+oy;
  e:=random(36)+1;
  drawimage(j,k,addr(ima[e]));
end;
fertig:=false;
end;


{ === Main Prog ========================================= }

begin
   initscreen(ok);
   if ok then begin
      holeimages;
      initstructures;
      zeichnescreen;
      initmouse;
      ende:=false;
      initliste;
      initgame;
      inithiscore;
      displayhiscore;
      while not ende do begin
         repeat
            mausauswerten;
            if fertig then begin
               fanfare;
               updathiscore(pkt);
            end;
         until ende or keypressed;
         if keypressed then ch:=readkey;
         ende:=ende or (ch=#27);
      end;
      textmode(3);
   end;
end.

